VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CAssociate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'********************************************************************************************
' MODULE - CAssociate.cls
'
' Written by Pranay Uppuluri
'     PRUppL@aol.com
'     http://members.xoom.com/win32realm (case should be lower case)
'     http://members.aol.com/PRUppL/
'
' This example is supplied with NO WARRANTY IMPLIED OR EXPRESS.
' USE IT AT YOUR OWN RISK!!!
'
' QuickHelp:
'      This following code will associate the file type
'      with extension .PRA with Windows NotePad.
'      NotePad should be in the C:\Windows\ folder
'
'      CODE:
'           Dim clsAssociate As New CAssociate
'
'           clsAssociate.Title = "A sample extension"  ' AKA Description of the file type
'           clsAssociate.Class = "A sample extension.NewExt"
'           clsAssociate.Extension = ".pra"
'           clsAssociate.AppCommand = "C:\Windows\Notepad.exe %1"  ' %1 is the file opening
'           clsAssociate.DefaultIcon = "C:\Windows\Notepad.exe, 2" ' Use icon 2 in Notepad
'           clsAssociate.Associate
'********************************************************************************************

' Public Properties
Public Title As String
Public Class As String
Public Extension As String
Public AppCommand As String
Public DefaultIcon As String

' advapi32...
Private Declare Function RegCreateKey& Lib "advapi32.DLL" Alias "RegCreateKeyA" (ByVal hKey&, ByVal lpszSubKey$, hKey&)
Private Declare Function RegSetValue& Lib "advapi32.DLL" Alias "RegSetValueA" (ByVal hKey&, ByVal lpszSubKey$, ByVal fdwType&, ByVal lpszValue$, ByVal dwLength&)

' return codes from Registration functions.
Private Const ERROR_SUCCESS = 0&
Private Const ERROR_BADDB = 1&
Private Const ERROR_BADKEY = 2&
Private Const ERROR_CANTOPEN = 3&
Private Const ERROR_CANTREAD = 4&
Private Const ERROR_CANTWRITE = 5&
Private Const ERROR_OUTOFMEMORY = 6&
Private Const ERROR_INVALID_PARAMETER = 7&
Private Const ERROR_ACCESS_DENIED = 8&
Private Const HKEY_CLASSES_ROOT = &H80000000
Private Const MAX_PATH = 256&
Private Const REG_SZ = 1

'********************************************************************************************
' Procedure  : Associate
' Purpose    : Associates the specified extension with specified program
'              and sets the icon supplied by the user.
'********************************************************************************************
Public Sub Associate()
Dim sKey As String     ' Key (+Key)
Dim KeyVal As String   ' Key Value
Dim rc As Long         ' Error value
Dim hKey As Long       ' handle for the key from RegCreateKey.
Dim AppTitle As String, AppClass As String, _
    AppCmdLine As String, DefIcon As String
    
    AppTitle = Title
    AppClass = Class
    AppCmdLine = AppCommand
    DefIcon = DefaultIcon
    
    If AppTitle = "" Then
        Err.Raise 898 + 24, "Associate Class", "Associate Class - Application title not specified"
        Exit Sub
    ElseIf AppClass = "" Then
        Err.Raise 898 + 28, "Associate Class", "Associate Class - Application Class name not specified"
        Exit Sub
    ElseIf AppCmdLine = "" Then
        Err.Raise 898 + 32, "Associate Class", "Associate Class - Command line of the program not specified"
        Exit Sub
    End If
    
    ' Create the root entry from the one supplied
    sKey = AppClass
    KeyVal = AppTitle
    rc& = RegCreateKey&(HKEY_CLASSES_ROOT, sKey, hKey&)
    rc& = RegSetValue&(hKey&, "", REG_SZ, KeyVal, 0&)
    
    ' Create an extension for the AppClass
    KeyVal = AppClass
    rc& = RegCreateKey&(HKEY_CLASSES_ROOT, Extension, hKey&)
    rc& = RegSetValue&(hKey&, "", REG_SZ, KeyVal, 0&)
       
    ' Set the command line for the App.
    ' The %1 will be replaced by the File name that got double clicked
    KeyVal = AppCmdLine & " %1"
    rc& = RegCreateKey&(HKEY_CLASSES_ROOT, sKey, hKey&)
    rc& = RegSetValue&(hKey&, "shell\open\command", REG_SZ, KeyVal, MAX_PATH)
    
    ' Create a key for the icon of this type of file
    rc& = RegSetValue&(hKey&, "DefaultIcon", REG_SZ, DefIcon, Len(DefIcon))
End Sub
